# Engines API
#
# Allow clients to fetch Engines Analytics through APIs.
#
# The version of the OpenAPI document: 2
# Contact: analytics.api.support@factset.com
# Generated by: https://openapi-generator.tech

#' @docType class
#' @title CalculationUnitStatus
#' @description CalculationUnitStatus Class
#' @format An \code{R6Class} generator object
#' @field status  character [optional]
#'
#' @field points  integer [optional]
#'
#' @field error  character [optional]
#'
#' @field result  character [optional]
#'
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CalculationUnitStatus <- R6::R6Class(
  'CalculationUnitStatus',
  public = list(
    `status` = NULL,
    `points` = NULL,
    `error` = NULL,
    `result` = NULL,
    initialize = function(`status`=NULL, `points`=NULL, `error`=NULL, `result`=NULL, ...){
      local.optional.var <- list(...)
      if (!is.null(`status`)) {
        stopifnot(is.character(`status`), length(`status`) == 1)
        self$`status` <- `status`
      }
      if (!is.null(`points`)) {
        stopifnot(is.numeric(`points`), length(`points`) == 1)
        self$`points` <- `points`
      }
      if (!is.null(`error`)) {
        stopifnot(is.character(`error`), length(`error`) == 1)
        self$`error` <- `error`
      }
      if (!is.null(`result`)) {
        stopifnot(is.character(`result`), length(`result`) == 1)
        self$`result` <- `result`
      }
    },
    toJSON = function() {
      CalculationUnitStatusObject <- list()
      if (!is.null(self$`status`)) {
        CalculationUnitStatusObject[['status']] <-
          self$`status`
      }
      if (!is.null(self$`points`)) {
        CalculationUnitStatusObject[['points']] <-
          self$`points`
      }
      if (!is.null(self$`error`)) {
        CalculationUnitStatusObject[['error']] <-
          self$`error`
      }
      if (!is.null(self$`result`)) {
        CalculationUnitStatusObject[['result']] <-
          self$`result`
      }

      CalculationUnitStatusObject
    },
    fromJSON = function(CalculationUnitStatusJson) {
      CalculationUnitStatusObject <- jsonlite::fromJSON(CalculationUnitStatusJson)
      if (!is.null(CalculationUnitStatusObject$`status`)) {
        self$`status` <- CalculationUnitStatusObject$`status`
      }
      if (!is.null(CalculationUnitStatusObject$`points`)) {
        self$`points` <- CalculationUnitStatusObject$`points`
      }
      if (!is.null(CalculationUnitStatusObject$`error`)) {
        self$`error` <- CalculationUnitStatusObject$`error`
      }
      if (!is.null(CalculationUnitStatusObject$`result`)) {
        self$`result` <- CalculationUnitStatusObject$`result`
      }
    },
    toJSONString = function() {
      jsoncontent <- c(
        if (!is.null(self$`status`)) {
        sprintf(
        '"status":
          "%s"
                ',
        self$`status`
        )},
        if (!is.null(self$`points`)) {
        sprintf(
        '"points":
          %d
                ',
        self$`points`
        )},
        if (!is.null(self$`error`)) {
        sprintf(
        '"error":
          "%s"
                ',
        self$`error`
        )},
        if (!is.null(self$`result`)) {
        sprintf(
        '"result":
          "%s"
                ',
        self$`result`
        )}
      )
      jsoncontent <- paste(jsoncontent, collapse = ",")
      paste('{', jsoncontent, '}', sep = "")
    },
    fromJSONString = function(CalculationUnitStatusJson) {
      CalculationUnitStatusObject <- jsonlite::fromJSON(CalculationUnitStatusJson)
      self$`status` <- CalculationUnitStatusObject$`status`
      self$`points` <- CalculationUnitStatusObject$`points`
      self$`error` <- CalculationUnitStatusObject$`error`
      self$`result` <- CalculationUnitStatusObject$`result`
      self
    }
  )
)
